unit GRFExport;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, TntForms, Contnrs, TntStdCtrls;

type
  TExportGrf = class(TTntForm)
    Label1: TLabel;
    GRFIDIn: TMaskEdit;
    SaveDialog1: TSaveDialog;
    Export: TButton;
    Cancel: TButton;
    LangIdIn: TMaskEdit;
    EditPatchTexts: TButton;
    EditSpecial: TButton;
    Label2: TLabel;
    LangIDHelp: TLabel;
    Label3: TLabel;
    GRFName: TTntEdit;
    Label4: TLabel;
    GRFDesc: TTntMemo;
    Label5: TLabel;
    ForceType: TComboBox;
    Help: TButton;
    Label6: TLabel;
    ChangeOsDep: TButton;
    GRFIDHelp: TLabel;
    procedure ExportClick(Sender: TObject);
    procedure TntFormShow(Sender: TObject);
    procedure TntFormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditPatchTextsClick(Sender: TObject);
    procedure EditSpecialClick(Sender: TObject);
    procedure LangIDHelpClick(Sender: TObject);
    procedure ChangeOsDepClick(Sender: TObject);
    procedure GRFIDHelpClick(Sender: TObject);
  private
    patchTexts: TObjectList;
    class procedure RemoveBadPatchTexts(texts:TObjectList);
  public
    { Public declarations }
  end;

var
  ExportGrf: TExportGrf;

implementation

{$R *.dfm}

uses FoProgi, GRFIO, ttdptxt, chSpec, ShellAPI, OsDep;

type
  TAction4Writer = class
  public
    constructor Create(dest:TGRF; langID:byte);
    destructor Destroy; override;
    procedure Put(ID:integer;const what:string);
    procedure Flush;
  private
    FDest: TGRF;
    FPartialAction: TMemoryStream;
    FStringCount: integer;
    FPrevID: integer;
    FLangID:byte;
  end;

  { TAction4Writer }

constructor TAction4Writer.Create(dest: TGRF; langID: byte);
begin
 FDest:=dest;
 FPrevID:=-10;
 FLangID:=langID;
end;

destructor TAction4Writer.Destroy;
begin
  Flush;
  inherited;
end;

procedure TAction4Writer.Flush;
begin
 if FPartialAction=nil then Exit;
 FPartialAction.Position:=3;
 FPartialAction.WriteBuffer(FStringCount,1);
 FDest.AddPseudoSprite(FPartialAction);
 FPartialAction:=nil;
 FStringCount:=0;
end;

procedure TAction4Writer.Put(ID:integer;const what:string);
var x:cardinal;
begin
 if (ID<>FPrevID+1) or (FStringCount=254) or ((ID and $F800)<>(FPrevID and $F800)) then
  Flush;
 if FPartialAction=nil then
  begin
   FPartialAction:=TMemoryStream.Create;
   x:=$00804804+(FLangID shl 16);
   FPartialAction.WriteBuffer(x,4);
   FPartialAction.WriteBuffer(ID,2);
  end;
 FPartialAction.WriteBuffer(PChar(what)^,Length(what)+1);
 inc(FStringCount);
 FPrevID:=ID;
end;

procedure TExportGrf.ExportClick(Sender: TObject);
var m,action7:TMemoryStream;
    grf:TGRF;
    i,x,GRFID,langid:cardinal;
    outf:TFileStream;
    currID,oldCount: integer;
    s,name,desc:string;
    ws:WideString;
    a4w:TAction4Writer;
begin
 with GrfIDIn do
  try
   GRFID:= StrToInt('$'+Copy(text,1,2)) + StrToInt('$'+Copy(text,4,2)) shl 8 +
           StrToInt('$'+Copy(text,7,2)) shl 16 + StrToInt('$'+Copy(text,10,2)) shl 24;
  except
   on EConvertError do
    begin
     Application.MessageBox('The GRFID isn''t filled correctly!'#13#10'It must contain 8 hex digits!',
                            'Invalid GRFID',MB_ICONERROR);
     Exit;
    end;
  end;

  try
   langid:=StrToInt('$'+LangIdIn.Text);
  except
   on EConvertError do
    begin
     Application.MessageBox('The language ID isn''t filled correctly!'#13#10'It must contain hex digits only!',
                            'Invalid langID',MB_ICONERROR);
     Exit;
    end;
  end;

 if not FoForm.CompileCStyleString(GRFName.Text,ws) then
  begin
   Application.MessageBox(PChar('There''s an error in the name field:'+#13+
                          string(ws)),'Error in name',MB_ICONERROR);
   exit;
  end;

 name:=FoForm.WideStringToTTDText(ws);

 if not FoForm.CompileCStyleString(GRFDesc.Text,ws) then
  begin
   Application.MessageBox(PChar('There''s an error in the description field:'+#13+
                          string(ws)),'Error in description',MB_ICONERROR);
   exit;
  end;

 desc:=FoForm.WideStringToTTDText(ws);

 if not SaveDialog1.Execute then Exit;
 outf:=TFileStream.Create(SaveDialog1.FileName,fmCreate or fmShareExclusive);
 grf:=TGRF.Create;

 if ForceType.ItemIndex=1 then
  begin
   m:=TMemoryStream.Create;
   x:=$03019207;
   m.WriteBuffer(x,4);
   x:=$0100;
   m.WriteBuffer(x,2);
   grf.AddPseudoSprite(m);
  end;

 if ForceType.ItemIndex>0 then
  begin
   m:=TMemoryStream.Create;
   x:=$010e;
   m.WriteBuffer(x,2);
   m.WriteBuffer(GRFID,4);
   grf.AddPseudoSprite(m);
  end;

 m:=TMemoryStream.Create;
 x:=$0708;
 m.WriteBuffer(x,2);
 m.WriteBuffer(GRFID,4);
 m.WriteBuffer(PChar(name)^,Length(name)+1);
 m.WriteBuffer(PChar(desc)^,Length(desc)+1);

 grf.AddPseudoSprite(m);

 m:=TMemoryStream.Create;
 x:=$0d;
 m.WriteBuffer(x,1);
 x:=$ffff009f;
 m.WriteBuffer(x,4);
 m.WriteBuffer(langid,1);
 m.WriteBuffer(ChangeSpec.specInfo.defaultUnit,1);
 m.WriteBuffer(ChangeSpec.specInfo.defaultCurr,1);
 x:=0;
 m.WriteBuffer(x,1);

 grf.AddPseudoSprite(m);

 {m:=nil;
 lastID:=-1000;
 stringCount:=0;

 with FoForm do
 for i:=1 to StringGrid1.RowCount-1 do
  begin

   currID:=Integer(StringGrid1.Objects[0,i]);

   if currID=-1 then Continue;
   if (currID<>lastID+1) or (stringCount=254) then
    begin
     if m<>nil then
      begin
       m.Position:=3;
       m.WriteBuffer(stringCount,1);
       grf.AddPseudoSprite(m);
      end;
     m:=TMemoryStream.Create;
     x:=$00804804+(langid shl 16);
     m.WriteBuffer(x,4);
     m.WriteBuffer(currID,2);
     stringCount:=0;
    end;

   if not CompileCStyleString(StringGrid1.Cells[2,i],ws) then
    ws:='Error!';
   s:=WideStringToTTDText(ws);
   m.WriteBuffer(PChar(s)^,Length(s)+1);
   inc(stringCount);

   lastID:=currID;
  end;

 m.Position:=3;
 m.WriteBuffer(stringCount,1);
 grf.AddPseudoSprite(m);}

 a4w:=TAction4Writer.Create(grf,langid);
 for i:=1 to FoForm.StringGrid1.RowCount-1 do
  begin
   currID:=Integer(FoForm.StringGrid1.Objects[0,i]);
   if currID=-1 then Continue;
   if not FoForm.CompileCStyleString(FoForm.StringGrid1.Cells[2,i],ws) then
    ws:='Error!';
   s:=FoForm.WideStringToTTDText(ws);
   a4w.Put(currID,s);
  end;

 if patchTexts<>nil then
  for i:=0 to patchTexts.Count-1 do
   with patchTexts[i] as TPatchText do
    begin
     s:=FoForm.WideStringToTTDText(Translated);
     a4w.Put(ID,s);
    end;

 s:=ChangeSpec.specInfo.transSpecTexts[1]+#$80;
 a4w.Put($BE,s);
 a4w.Put($E049,ChangeSpec.specInfo.transSpecTexts[2]);
 a4w.Put($E04a,ChangeSpec.specInfo.transSpecTexts[3]);
 a4w.Put($E04b,ChangeSpec.specInfo.transSpecTexts[4]);
 a4w.Put($E04c,ChangeSpec.specInfo.transSpecTexts[5]);

 a4w.Put($E042,ChangeSpec.specInfo.initials);
 a4w.Put($E043,ChangeSpec.specInfo.initials);

 if ChangeSpec.specInfo.useCustomDate then
  begin
   a4w.Put($F8e3,ChangeSpec.specInfo.customShortDate);
   a4w.Put($F8e4,ChangeSpec.specInfo.customLongDate);
  end;

 for i:=1 to 13 do
  begin
   a4w.Put($Dc00+i-1,ChangeSpec.specInfo.transCurrNames[i]);
  end;

 a4w.Flush;

 m:=TMemoryStream.Create;
 x:=$0d010800;
 m.WriteBuffer(x,4);
 x:=$0A06;
 m.WriteBuffer(x,2);
 for x:=$DC00 to $DC0C do
  m.WriteBuffer(x,2);

 grf.AddPseudoSprite(m);

 if EditOSDep.settings.changed<>[] then
  begin
   action7:=TMemoryStream.Create;
   x:=$03018d07;
   action7.WriteBuffer(x,4);
   if EditOSDep.settings.destOsIsDos then
    x:=$00
   else
    x:=$01;
   action7.WriteBuffer(x,1);
   grf.AddPseudoSprite(action7);
   oldCount:=grf.SpriteCount;
   for i:=1 to NumOsDepStr do
    if i in EditOSDep.settings.changed then
     a4w.Put(EditOSDep.settings.textIDs[i],EditOSDep.settings.transTexts[i]);
   a4w.Flush;
   x:=grf.SpriteCount-oldCount;
   action7.WriteBuffer(x,1);
  end;

 a4w.Free;

 grf.WriteToStreamAsPatchGRF(outf);
 outf.Free;
 grf.Free;

 Application.MessageBox('GRF saved successfully','Success',MB_ICONINFORMATION);
 ModalResult:=mrOK;
end;

procedure TExportGrf.TntFormShow(Sender: TObject);
var origExe,transExe:TFileStream;
    i:integer;

begin
 patchTexts:=InGameText.GetPatchTexts;
 EditPatchTexts.Enabled:= patchTexts<>nil;
 origExe:=TFileStream.Create(OrigExePath,fmOpenRead or fmShareDenyWrite);
 transExe:=TFileStream.Create(TransExePath,fmOpenRead or fmShareDenyWrite);
 ChangeSpec.GetSpecInfo(origExe,transExe);
 origExe.Free;
 transExe.Free;
 if patchTexts<>nil then
 begin
  for i:=0 to patchTexts.Count-1 do
   with patchTexts[i] as TPatchText do
    if ID-$F800 in [$57..$63] then
     begin
      ChangeSpec.specInfo.origCurrNames[ID-$F856]:=PChar(FoForm.WideStringToTTDText(original));
      ChangeSpec.specInfo.transCurrNames[ID-$F856]:=PChar(FoForm.WideStringToTTDText(translated));
     end;
  RemoveBadPatchTexts(patchTexts);
 end;
 InGameText.DestList:=patchTexts;
 EditOSDep.LoadSettings;
end;

procedure TExportGrf.TntFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 FreeAndNil(patchTexts);
 InGameText.DestList:=nil;
end;

class procedure TExportGrf.RemoveBadPatchTexts(texts: TObjectList);
var i,j:integer;
    txt:TPatchText;
    delete:boolean;
    trans:WideString;
begin
 i:=0;
 while i<texts.Count do
  begin
   delete:=false;
   txt:=texts[i] as TPatchText;
   if (txt.ID=-1) or ((txt.ID-$f800) in [$57..$63,$af,$dd..$e4]) then
    delete:=true;
   trans:=txt.Translated;
   for j:=1 to Length(trans) do
    if trans[j]=#0 then
     begin
      delete:=true;
      break;
     end;
   if delete then
    texts.Delete(i)
   else
    inc(i);
  end;
end;

procedure TExportGrf.EditPatchTextsClick(Sender: TObject);
begin
 if InGameText.ShowModal=mrOK then
  RemoveBadPatchTexts(patchTexts);
end;

procedure TExportGrf.EditSpecialClick(Sender: TObject);
begin
 ChangeSpec.invokedForGRF:=true;
 ChangeSpec.ShowModal;
 ChangeSpec.invokedForGRF:=false;
end;

procedure TExportGrf.LangIDHelpClick(Sender: TObject);
begin
 ShellExecute(Application.Handle,nil,
              'http://wiki.ttdpatch.net/tiki-index.php?page=Action4#language_id',
              nil,nil,0);
end;

procedure TExportGrf.ChangeOsDepClick(Sender: TObject);
begin
 EditOSDep.ShowModal;
end;

procedure TExportGrf.GRFIDHelpClick(Sender: TObject);
begin
 ShellExecute(Application.Handle,nil,
              'http://wiki.ttdpatch.net/tiki-index.php?page=Action8#GRF_ID',
              nil,nil,0);
end;

end.
