unit GRFIO;

interface
uses Classes,Contnrs;

type
  TGRF = class
  private
    sprites: TObjectList;
    procedure WriteSprite(source: TStream; dest: TStream);
    function GetSpriteCount: integer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure AddPseudoSprite(psprite: TStream);
    procedure Clear;
    procedure WriteToStream(dest: TStream);
    procedure WriteToStreamAsPatchGRF(dest: TStream);
    property SpriteCount: integer read GetSpriteCount;
  end;

implementation

{ TGRF }

procedure TGRF.AddPseudoSprite(psprite: TStream);
begin
 sprites.Add(psprite);
end;

procedure TGRF.Clear;
begin
 sprites.Clear;
end;

constructor TGRF.Create;
begin
 sprites:=TObjectList.Create;
end;

destructor TGRF.Destroy;
begin
  sprites.free;
  inherited;
end;

function TGRF.GetSpriteCount: integer;
begin
 Result:=sprites.Count;
end;

procedure TGRF.WriteSprite(source: TStream; dest: TStream);
var w:word;
begin
 w:=source.Size;
 dest.WriteBuffer(w,2);
 w:=$FF;
 dest.WriteBuffer(w,1);
 dest.CopyFrom(source,0);
end;

procedure TGRF.WriteToStream(dest: TStream);
var i: cardinal;
begin
 for i:=0 to sprites.Count-1 do
  WriteSprite(TStream(sprites[i]),dest);
 i:=0;
 dest.WriteBuffer(i,4);
 dest.WriteBuffer(i,2);
end;

procedure TGRF.WriteToStreamAsPatchGRF(dest: TStream);
var m: TMemoryStream;
    i: cardinal;
begin
 m:=TMemoryStream.Create;
 i:=sprites.Count;
 m.WriteBuffer(i,4);
 sprites.Insert(0,m);
 WriteToStream(dest);
 sprites.Delete(0);
end;

end.
