unit Helper;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


const ExeTypes:array[1..10] of record
                                FileSize:integer;
                                PointerLists:pointer;
                                StringLists:pointer;
                                CheckDateOffset:integer;
                               end=
       {American DOS}
      ((FileSize:496543; PointerLists:nil; StringLists:nil;CheckDateOffset:$3558c),
       {English DOS}
       (FileSize:496601; PointerLists:nil; StringLists:nil;CheckDateOffset:$355c6),
       {French DOS}
       (FileSize:505759; PointerLists:nil; StringLists:nil;CheckDateOffset:$3796c),
       {German DOS}
       (FileSize:499583; PointerLists:nil; StringLists:nil;CheckDateOffset:$3614c),
       {Spanish DOS}
       (FileSize:506237; PointerLists:nil; StringLists:nil;CheckDateOffset:$37b4a),
       {American Windows}
       (FileSize:1695744; PointerLists:nil; StringLists:nil;CheckDateOffset:$13cd2f),
       {English Windows}
       (FileSize:1696256; PointerLists:nil; StringLists:nil;CheckDateOffset:$13cf2f),
       {French Windows}
       (FileSize:1707008; PointerLists:nil; StringLists:nil;CheckDateOffset:$13f92f),
       {German Windows}
       (FileSize:1699328; PointerLists:nil; StringLists:nil;CheckDateOffset:$13db2f),
       {Spanish Windows}
       (FileSize:1707520; PointerLists:nil; StringLists:nil;CheckDateOffset:$13fb2f));

var
  Form1: TForm1;

implementation

{$R *.DFM}

function GetFileSize(const name:string):integer;
{There's no built-in function to get the filesize from filename so I had to write one}
var f:file;
begin
 FileMode:=0; {We don't want to make error when opening read-only files}
 AssignFile(f,name);
 Reset(f,1);
 Result:=FileSize(f);
 Close(f);
 FileMode:=2;
end;

function FindVersion(filesize: integer): integer;
{Find version from filesize. If filesize is unknown, it returns -1}
var i:integer;
begin
 Result:=-1;
 for i:= Low(ExeTypes) to High(ExeTypes) do
  if ExeTypes[i].FileSize=filesize then
   Result:=i;
end;

procedure TForm1.FormCreate(Sender: TObject);
var fname:string;
    f:TFileStream;
    k:textfile;
    ftype,offset,i:integer;
    t:array of byte;

procedure writebytes;
var i:integer;
begin
 for i:=low(t) to high(t) do
  write(k,'$',IntToHex(t[i],2),',');
 writeln(k);
end;

begin
 while OpenDialog1.Execute do
  begin
   fname:=OpenDialog1.FileName;
   ftype:=FindVersion(GetFileSize(fname));
   if ftype=-1 then Continue;
   f:=TFileStream.Create(fname,fmOpenRead or fmShareDenyWrite);
   AssignFile(k,ChangeFileExt(fname,'.txt'));
   Rewrite(k);
   offset:=ExeTypes[ftype].CheckDateOffset;
{   f.Position:=offset-259;
   SetLength(t,10);
   f.ReadBuffer(t[0],10);
   writebytes;
   f.Position:=offset-179;
   f.ReadBuffer(t[0],10);
   writebytes;
   f.Position:=offset;
   SetLength(t,51);
   f.ReadBuffer(t[0],51);
   writebytes;
   f.Position:=offset+80;
   SetLength(t,92);
   f.ReadBuffer(t[0],92);
   writebytes;}
   f.Position:=offset+10;
   f.ReadBuffer(i,4);
   write(k,'$',IntToHex(i,8),',');
   f.Position:=offset+23;
   f.ReadBuffer(i,4);
   write(k,'$',IntToHex(i,8),',');
   f.Position:=offset+136;
   f.ReadBuffer(i,4);
   write(k,'$',IntToHex(i,8));
   writeln(k);
   f.Free;
   CloseFile(k);
  end;
 Application.Terminate;
end;

end.
