unit OsDep;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, TntGrids, ExtCtrls, AppEvnts, TntForms;

const NumOsDepStr=10;

type
  TOsDepTextSettings=record
   textIDs:array[1..NumOsDepStr] of integer;
   origTexts,transTexts:array[1..NumOsDepStr] of string;
   changed:set of 1..NumOsDepStr;
   destOsIsDos:boolean;
  end;

type
  TEditOSDep = class(TTntForm)
    StringGrid1: TTntStringGrid;
    OK: TButton;
    Cancel: TButton;
    PreviewTimer: TTimer;
    ApplicationEvents1: TApplicationEvents;
    LoadFromExported: TButton;
    OpenDialog1: TOpenDialog;
    Info: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1Exit(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormShow(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PreviewTimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ApplicationEvents1Activate(Sender: TObject);
    procedure ApplicationEvents1Deactivate(Sender: TObject);
    procedure LoadFromExportedClick(Sender: TObject);
  private
    { Private declarations }
    function CheckCError:boolean;
    function TTDTextFromCStyle(const CStyle:WideString):string;
  public
    { Public declarations }
    OrigString:WideString;
    settings:TOsDepTextSettings;
    procedure LoadSettings;
  end;

var
  EditOSDep: TEditOSDep;

implementation

{$R *.dfm}

uses FoProgi, previewf;

type
  OsDependentText=record
   StringNum,TextID: integer;
   DosText,WinText: WideString;
  end;

const OsDepTexts: array [1..NumOsDepStr] of OsDependentText= (
 ( StringNum:184; TextID:$00B7;
   DosText:'\cgVersion 2.01.119  21st September 1995 19:52:31';
   WinText:'\cgVersion 3.02.011  11th October 1996 17:23:14'; ),
 ( StringNum:187; TextID:$00BA;
   DosText:'\cgMusic by John Broomhall\n'+
           'Sound Programming by Andrew Parton\n\n'+

           'Quality Assurance:\n'+
           'Andrew Luckett, Don Witcombe, Craig Lear, Daniel Luton,\n'+
           'Jason Sampson, Darren Kirby, Phil McDonnell, Patrice Stauder\n'+
           'Installation by Tim Cannell\n'+
           'Producer: Mike Rudderham\n\n'+

           'Thanks to: Jacqui Lyons at Marjacq Micro\n';
   WinText:'\cgWindows''95 conversion by FISH (UK) Ltd.\n'+
           'Programmed by Joe Booth\n'+
           'Additional code by Nick Tuckett\n'+
           'Win''95 specific code  1996 FISH Technology Group\n\n'+

           'Music by John Broomhall\n'+
           'Sound Programming by Andrew Parton\n\n'+

           'Quality Assurance:\n'+
           'Andrew Luckett, Don Witcombe, Craig Lear, Daniel Luton, Justin Manning,\n'+
           'Jason Sampson, Darren Kirby, Phil McDonnell, Patrice Stauder\n\n'+

           'Produced by Grant Dean and James Hawkins\n'+
           'Producer for ITOCHU: Yasuo Kojima\n'+
           'Executive Producer: Mike Rudderham\n\n'+

           'Thanks to: Jacqui Lyons at Marjacq Micro\n'; ),
 ( StringNum:198; TextID:$00C7;
   DosText:'\ccQuit to DOS';
   WinText:'\ccQuit'; ),
 ( StringNum:201; TextID:$00CA;
   DosText:'\c8Are you sure you want to quit this game and quit to DOS ?';
   WinText:'\c8Are you sure you want to abandon this game and return to Windows ?'; ),
 ( StringNum:350; TextID:$015F;
   DosText:'Quit to DOS';
   WinText:'Quit'; ),
 ( StringNum:369; TextID:$0172;
   DosText:'\cgSave game, quit game, quit to DOS';
   WinText:'\cgSave game, abandon game, quit'; ),
 ( StringNum:661; TextID:$0296;
   DosText:'Quit to DOS';
   WinText:'Quit'; ),
 ( StringNum:662; TextID:$0297;
   DosText:'\cgSave scenario, load scenario, quit scenario editor, quit to DOS';
   WinText:'\cgSave scenario, load scenario, abandon scenario editor, quit'; ),
 ( StringNum:771; TextID:$0304;
   DosText:'\cgQuit to DOS';
   WinText:'\cgQuit'; ),
 ( StringNum:772; TextID:$305;
   DosText:'\cgLeave ''Transport Tycoon'', and quit to DOS';
   WinText:'\cgLeave ''Transport Tycoon'', and quit'; ));

{ TEditOSDep }

function TEditOSDep.TTDTextFromCStyle(const CStyle:WideString):string;
var tmp:WideString;
begin
 if not FoForm.CompileCStyleString(CStyle,tmp) then
  tmp:='-- Error --';
 Result:=FoForm.WideStringToTTDText(tmp);
end;


procedure TEditOSDep.LoadSettings;
var i:integer;

begin
 settings.destOsIsDos := TransType>5;
 settings.changed:=[];
 for i:= 1 to NumOsDepStr do
  begin
   settings.textIDs[i]:=osDepTexts[i].TextID;
   if settings.destOsIsDos then
    settings.origTexts[i]:=TTDTextFromCStyle(osDepTexts[i].DosText)
   else
    settings.origTexts[i]:=TTDTextFromCStyle(osDepTexts[i].WinText);
   settings.transTexts[i]:=TTDTextFromCStyle(FoForm.StringGrid1.Cells[2,osDepTexts[i].StringNum]);
  end;
end;

procedure TEditOSDep.FormCreate(Sender: TObject);
begin
 StringGrid1.Cells[0,0]:='TextID';
 StringGrid1.Cells[1,0]:='Original';
 StringGrid1.Cells[2,0]:='Translated';
end;

function TEditOSDep.CheckCError: boolean;
var s:WideString;
begin
 with StringGrid1 do
  if not FoForm.CompileCStyleString(Cells[Col,Row],s) then
   begin
    result:=false;
    Application.MessageBox(PChar('The C-style string you entered has an error:'#10#13+string(s)+#10#13'You must fix this error to continue or press ESC to undo your changes'),'Error in string',MB_ICONERROR);
   end
  else
   result:=true;
end;

procedure TEditOSDep.StringGrid1Exit(Sender: TObject);
begin
 if not CheckCError then StringGrid1.SetFocus; {If there's error in the current cell, the string grid
                                                prevents losing focus}
end;

procedure TEditOSDep.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
 with StringGrid1 do
  if (Key=#13) and EditorMode and not CheckCError then
  {The user wants to exit editor mode by pressing Enter, but there's an error in the text,
   so we can't allow pressing Enter}
   Key:=#0
  else if (Key=#13) and not EditorMode then
  {The user enters editor mode, but we save the original text first, so we can restore it
   when the user presses Esc}
   OrigString:=Cells[Col,Row]
  else if Key=#27 then
   begin
    {The user presses Esc - we restore the original text}
    Cells[Col,Row]:=OrigString;
    EditorMode:=false;
   end;
end;

procedure TEditOSDep.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
 if not CheckCError then {If there's an error in the current cell, we don't allow to leave it}
  begin
   CanSelect:=false;
   Exit;
  end;
 if CanSelect then
  with StringGrid1 do
    OrigString:=Cells[ACol,ARow];
end;

procedure TEditOSDep.FormShow(Sender: TObject);
var i:integer;
    baseOS,destOS:string;
begin
 if TransType>5 then
  begin
   baseOS:='Windows'; destOS:='DOS';
  end
 else
  begin
   baseOS:='DOS'; destOS:='Windows';
  end;
 Info.Caption:='The EXE file loaded is for the '+baseOS+' version of TTD. '+
               'This is a list of texts that are different in the '+destOS+
               ' version. Supplying these extra translations will allow the '
               +'GRF to work correctly both in the DOS and Windows versions.';     
 for i:=1 to NumOsDepStr do
  begin
   StringGrid1.Cells[0,i]:=IntToHex(settings.textIDs[i],4)+'h';
   StringGrid1.Cells[1,i]:=FoForm.MakeCStyleString(FoForm.TTDTextToWideString(settings.origTexts[i]));
   StringGrid1.Cells[2,i]:=FoForm.MakeCStyleString(FoForm.TTDTextToWideString(settings.transTexts[i]));
  end;
 PreviewTimer.Enabled:=FoForm.Preview.Checked;
 if FoForm.Preview.Checked then
  begin
   EnableWindow(PreviewForm.Handle,true);
   SetWindowPos(PreviewForm.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE);
  end;
end;

procedure TEditOSDep.OKClick(Sender: TObject);
var i:integer;
    old,new:WideString;
begin
 if not CheckCError then Exit;
 settings.changed:=[];
 for i:=1 to NumOsDepStr do
  begin
   old:=FoForm.StringGrid1.Cells[2,osDepTexts[i].StringNum];
   new:=StringGrid1.Cells[2,i];
   if old<>new then
    include(settings.changed,i);
   settings.transTexts[i]:=TTDTextFromCStyle(new);
  end;
 ModalResult:=mrOK;
end;

procedure TEditOSDep.FormResize(Sender: TObject);
var remainingSpace: integer;
begin
 with StringGrid1 do
  begin
   StringGrid1.ColWidths[0]:=50;
   remainingSpace:=ClientWidth-ColWidths[0]-5;
   ColWidths[1]:=remainingSpace div 2;
   ColWidths[2]:=remainingSpace div 2;
  end;
end;

procedure TEditOSDep.PreviewTimerTimer(Sender: TObject);
begin
 if not PreviewForm.Visible then PreviewTimer.Enabled:=false;
 With StringGrid1 do
  PreviewForm.PreviewText:=StringGrid1.Cells[Col,Row];
end;

procedure TEditOSDep.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 PreviewTimer.Enabled:=false;
 SetWindowPos(PreviewForm.Handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE);
end;

procedure TEditOSDep.ApplicationEvents1Activate(Sender: TObject);
begin
 if not Visible then Exit;
 ShowWindow(Application.Handle,SW_RESTORE);
 SetFocus;
 if FoForm.Preview.Checked then
  SetWindowPos(PreviewForm.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE);
end;

procedure TEditOSDep.ApplicationEvents1Deactivate(Sender: TObject);
begin
 if not Visible then Exit;
 if FoForm.Preview.Checked then
  begin
   SetWindowPos(PreviewForm.Handle,Handle,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE);
   SetWindowPos(Handle,PreviewForm.Handle,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE);
  end;
end;

procedure TEditOSDep.LoadFromExportedClick(Sender: TObject);
var texts:TAllTTDStrings;
    occurs:TBoolForAllTTDStrings;
    err:string;
    source:TextFile;
    i,num:integer;
begin
 if not OpenDialog1.Execute then Exit;
 assignFile(source,OpenDialog1.FileName);
 reset(source);
 if not FoForm.ImportFromFile(source,texts,occurs,err) then
  begin
   CloseFile(source);
   Application.MessageBox(PChar(err),'Error in input file',MB_ICONERROR or MB_OK);
  end;
 CloseFile(source);
 for i:=1 to NumOsDepStr do
  begin
   num:=osDepTexts[i].StringNum;
   if occurs[num] then StringGrid1.Cells[2,i]:=FoForm.MakeCStyleString(texts[num]);
  end;
end;

end.
