unit SaveF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, TntForms;

type
  TFormSave = class(TTntForm)
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure DoSave(var msg:TMessage); message wm_USER;
  public
    { Public declarations }
  end;

var
  FormSave: TFormSave;

implementation

uses FoProgi;

{$R *.DFM}

{ TFormSave }

procedure TFormSave.DoSave(var msg: TMessage);
var short,pointers:array [1..2449] of cardinal;
    i,j,k:integer;
    w:word;
    Strings:array[1..2449] of string;
    s,s2:WideString;
    f:TMemoryStream;
    PointerLists:PPointerListInfo;
    StringLists:PStringListInfo;
begin
{We can start the real saving here}
f:=nil; {We set f to nil, so there will be no error if an exception raises before f is created
         because Free only proceeds when the object isn't nil}
try
Screen.Cursor:=crHourGlass;
PointerLists:=ExeTypes[TransType].PointerLists;
StringLists:=ExeTypes[TransType].StringLists;
Label1.Caption:='Shortening strings...';
FillChar(short,sizeof(short),0);
FillChar(pointers,sizeof(pointers),0);
{We load the strings into a local array - we can access them quicker here and we don't have to use
 properties. Speed is essential because we need to access strings many times while shortening}
for i:=1 to 2449 do
 begin
  s:=FoForm.StringGrid1.Cells[2,i];
{We convert C-style strings to normal strings}
  if FoForm.CompileCStyleString(s,s2) then
   strings[i]:=FoForm.WideStringToTTDText(s2)
  else
   begin
    MessageBoxW(Application.Handle,PWideChar('C-string error in string number '+IntToStr(i)+':'#10#13+s+#10#13'The string won''t be saved'),'C-style error',MB_ICONERROR);
    strings[i]:='-Error!-';
   end;
 end;
for i:=353 to 364 do {Short month names should be three characters long - if they aren't, we must
                      adjust their length}
 if Length(strings[i])>3 then
  SetLength(Strings[i],3)
 else
  while Length(Strings[i])<3 do
   strings[i]:=strings[i]+' ';
for i:=1 to 2449 do
 begin
  if (i>352) and (i<365) then  continue;
  {We can't shorten short month names (Jan,Feb...). They have to be after each other in increasing
   order, because the date-showing code-part assumes them to be this way}
  if (i mod 10)=0 then
  {We refresh the progress bar after every 10th string. If we did it after each string, the redrawing
   would take more time than the shortening itself}
  begin
   ProgressBar1.Position:=i;
   Label2.Caption:=IntToStr(i)+'/2449 strings completed';
   Application.ProcessMessages;
  end;
  s:=strings[i];
  for j:=1 to 2449 do
   {We use only unshortened strings for shortening, so we can avoid recursive shortenings.
    To shorten a string, it has to exactly match the end of another string.}
   if (short[j]=0) and (i<>j) and
      (Length(Strings[j])>=Length(s)) and
      (Copy(Strings[j],Length(Strings[j])-Length(s)+1,Length(s))=s) then
    begin
     short[i]:=j;
     Break;
    end;
 end;
Label1.Caption:='Arranging shortenings...';
{We may still have shortenings of the type a->b->c (a is shortened using b, but b is shortened, too,
 using c. In this case, a can be shortened using c).We follow these chains until we find their last
 string}
for i:=1 to 2449 do
 begin
  if (i mod 10)=0 then
  begin
  {We redraw only after arranging 10 shortenings}
   ProgressBar1.Position:=i;
   Label2.Caption:=IntToStr(i)+'/2449 strings completed';
   Application.ProcessMessages;
  end;
  j:=short[i];
  while (j<>0) and (short[j]<>0) do
    j:=short[j];
  if j<>0 then
   FoForm.StringGrid1.Cells[3,i]:=IntToStr(j)
  else
   FoForm.StringGrid1.Cells[3,i]:='';
  short[i]:=j;
 end;
f:=TMemoryStream.Create;
f.LoadFromFile(TransExePath);
{Now we can write unshortened strings to the file. We work in a TMemoryStream, and if something
 goes wrong, we simply free this stream without saving it.
 K will be the number of strings to be saved}
k:=0;
for i:=1 to 2449 do
 if (short[i]=0) and ((i<353) or (i>364)) then inc(k);
{We write as many strings in a string list as possible.}
for i:=low(StringLists^) to high(StringLists^) do
 begin
  f.Position:=StringLists^[i].s;
  for j:=1 to 2449 do
   {We check every string if it fits in the remaining space of the string list.
    We don't save short month names yet, because they have to be after each other, not just anywhere}
    if ((j<353) or (j>364)) and (pointers[j]=0) and (short[j]=0) and
      ((StringLists^[i].e-f.Position)>=Length(strings[j])) then
    begin
     {If it fits, we write it and store the appropriate pointer}
     pointers[j]:=f.position+StringLists^[i].o;
     f.WriteBuffer(PChar(strings[j])^,Length(strings[j])+1);
     dec(k);
    end;
  if k=0 then break; {If we wrote out all strings, we can stop}
 end;
{We arrive here with f.Position set to the first available free byte and i set to the number of the
 string list it is situated. If there is less than 48 free bytes in the current string list, we jump
 to the next one where there is}
while ((StringLists^[i].e-f.Position+1)<48) and (i<=high(StringLists^)) do
begin
 inc(i);
 if i<=high(StringLists^) then
  f.Position:=StringLists^[i].s;
end;
{If i is greater than the last string list, it means that we've run out of space - we can't save.
If k is greater than zero then not all text could be saved.}
if (i>high(StringLists^)) or (k>0) then
 begin
  ShowMessage('Not enough space in the executable file - try to be shorter');
  Screen.Cursor:=crDefault;
  FoForm.Cursor:=crDefault;
  modalResult:=mrCancel;
  Exit;
 end;
{We have enough space so we write out short month names}
for j:=353 to 364 do
 begin
  pointers[j]:=f.position+StringLists^[i].o;
  f.WriteBuffer(PChar(strings[j])^,4);
 end;
{now we count remaining bytes in k}
k:=StringLists^[i].e-f.Position+1;
for j:=i+1 to high(StringLists^) do
 k:=k+StringLists^[j].e-StringLists^[j].s+1;
{We compute the pointers of shortened strings - they must point to the correct character}
for i:=1 to 2449 do
 if short[i]<>0 then
  pointers[i]:=Pointers[short[i]]+Length(strings[short[i]])-Length(strings[i]);
{Now we're ready to write pointer lists. The array "pointers" stores all pointers in the correct order,
we only need to split it into pointer lists}
j:=1;
for i:=low(PointerLists^) to high(PointerLists^) do
 begin
  f.Position:=PointerLists^[i].s;
  f.WriteBuffer(pointers[j],PointerLists^[i].e-PointerLists^[i].s+1);
  j:=j+(PointerLists^[i].e-PointerLists^[i].s+1) div 4;
 end;
{Now we write the offset of "Jan" into the code, but we need to know if it's the Hungarian version.
 We read four bytes from CheckDateOffset and decide the version from it}
f.Position:=ExeTypes[TransType].CheckDateOffset;
f.ReadBuffer(w,2);
if w=$6650 then
{Original version}
 f.Position:=ExeTypes[TransType].CheckDateOffset+163
else if w=$5066 then
{Hungarian version}
 f.Position:=ExeTypes[TransType].CheckDateOffset+158;
{We write the offset}
f.WriteBuffer(pointers[353],4);
{And we can save everytihng}
f.SaveToFile(TransExePath);
FoForm.Hint:=IntToStr(k)+' unused bytes remaining';
FoForm.changed:=false;
finally
f.free;
ModalResult:=mrOK;
Screen.Cursor:=crDefault;
end;
end;

procedure TFormSave.FormShow(Sender: TObject);
begin
 {We can't save in the OnShow handler - the window isn't visible yet. We send a message to ourselves,
  because we will get it only when the window is visible}
 PostMessage(Handle,WM_USER,0,0);
end;

end.
