unit previewf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus, TntComCtrls, TntForms;

type
  TPreviewForm = class(TTntForm)
    RichEdit1: TTntRichEdit;
    PopupMenu1: TPopupMenu;
    Changedefaulttextcolor1: TMenuItem;
    Changebackgroundcolor1: TMenuItem;
    ColorDialog1: TColorDialog;
    Double: TMenuItem;
    UseTTDFont: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Changedefaulttextcolor1Click(Sender: TObject);
    procedure Changebackgroundcolor1Click(Sender: TObject);
    procedure DoubleClick(Sender: TObject);
    procedure UseTTDFontClick(Sender: TObject);
  private
    FPreviewText:WideString;
    procedure SetPreviewText(const Value: Widestring);
    procedure RefreshText(const s:WideString);
    { Private declarations }
  public
    property PreviewText:WideString write SetPreviewText;
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation
uses FoProgi;
{$R *.DFM}

{ TPreviewForm }

procedure TPreviewForm.SetPreviewText(const Value: WideString);
var s:WideString;
begin
 if not FoForm.CompileCStyleString(Value,s) then
  Exit;
 if s<>FPreviewText then
  begin
   FPreviewText:=s;
   RefreshText(s);
  end;
end;

procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 FoForm.Preview.Execute;
end;

procedure TPreviewForm.RefreshText(const s: WideString);
var s2:WideString;
    i:integer;
begin
 With RichEdit1 do
  begin
   Lines.Clear;
   With SelAttributes do
    begin
     Color:=Font.Color;
     Font.Size:=8;
    end;
   for i:=1 to Length(s) do
   begin
    SelAttributes.Name:=Font.Name;
    SelAttributes.Charset:=Font.Charset;
    SelAttributes.Style:=Font.Style;
    SelAttributes.Size:=Font.Size;
    s2:='';
    case s[i] of
     #13: s2:=#13#10;
     #14: if Double.Checked then
           Font.Size:=10
          else Font.Size:=5;
     #15: Font.Size:=14;
     #$e07b: s2:=s2+'123,456';
     #$e07c: s2:=s2+'12,345';
     #$e07d: s2:=s2+'123';
     #$e07e: s2:=s2+'1995';
     #$e07f: s2:=s2+'$123,456';
     #$e080: s2:=s2+'*text*';
     #$e082: s2:=s2+'20th Jun 1995';
     #$e083: s2:=s2+'June 1995';
     #$e084: s2:=s2+'123kmh'+WideChar(#185);
     #$e085: ; //do nothing
     #$e087: s2:=s2+'12,300 liters';
     #$e088..#$e098: SelAttributes.Color:=Colors[Ord(s[i])-$e087];
    else
      s2:=s[i];
    end;
//    if s2<>'' then
//     SendMessage(Handle,EM_REPLACESEL,0,Integer(PChar(string(s2))));
     SelText:=s2;
   end;
  SendMessage(Handle,EM_LINESCROLL,0,-SendMessage(Handle,EM_GETFIRSTVISIBLELINE,0,0));
  end;
end;

procedure TPreviewForm.Changedefaulttextcolor1Click(Sender: TObject);
begin
 ColorDialog1.Color:=RichEdit1.Font.Color;
 if ColorDialog1.Execute then
  begin
   RichEdit1.Font.Color:=ColorDialog1.Color;
   RefreshText(FPreviewText);
  end;
end;

procedure TPreviewForm.Changebackgroundcolor1Click(Sender: TObject);
begin
 ColorDialog1.Color:=RichEdit1.Color;
 if ColorDialog1.Execute then
  RichEdit1.Color:=ColorDialog1.Color;
end;

procedure TPreviewForm.DoubleClick(Sender: TObject);
begin
 Double.Checked:=not Double.Checked;
 RefreshText(FPreviewText);
end;

procedure TPreviewForm.UseTTDFontClick(Sender: TObject);
begin
 UseTTDFont.Checked:=not UseTTDFont.Checked;
 if UseTTDFont.Checked then
  with RichEdit1.Font do
   begin
    Name:='Transport Tycoon';
    Charset:=ANSI_CHARSET;
    Style:=[];
   end
 else
  RichEdit1.ParentFont:=true;
 RichEdit1.SelAttributes.Assign(RichEdit1.Font);
 RefreshText(FPreviewText);
end;

end.
